# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `numdiff` Chapter.
"""

# NAG Copyright 2017-2019.

from ..base import utils

fwd_f = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_FLOAT64, # Input, x.
)
fwd = utils._EngineState._get_symbol('d04aaf')
fwd.restype = None
fwd.argtypes = (
    utils._BYREF_FLOAT64, # Input, xval.
    utils._BYREF_INT, # Input, nder.
    utils._BYREF_FLOAT64, # Input, hbase.
    utils._EngineFloat64ArrayType.c_type, # Output, der[14].
    utils._EngineFloat64ArrayType.c_type, # Output, erest[14].
    fwd_f,
    utils._BYREF_INT, # Input/Output, ifail.
)

rcomm = utils._EngineState._get_symbol('d04baf')
rcomm.restype = None
rcomm.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, xval[21].
    utils._EngineFloat64ArrayType.c_type, # Input, fval[21].
    utils._EngineFloat64ArrayType.c_type, # Output, der[14].
    utils._EngineFloat64ArrayType.c_type, # Output, erest[14].
    utils._BYREF_INT, # Input/Output, ifail.
)

sample = utils._EngineState._get_symbol('d04bbf')
sample.restype = None
sample.argtypes = (
    utils._BYREF_FLOAT64, # Input, x_0.
    utils._BYREF_FLOAT64, # Input, hbase.
    utils._EngineFloat64ArrayType.c_type, # Output, xval[21].
)
