u"""
Package Summary
---------------
Base utilities and interfaces for accessing the NAG Library Engine from
Python.

Submodule Summary
-----------------
The :mod:`~naginterfaces.base.utils` submodule provides:

- a hierarchy of exceptions (including :class:`~utils.NagException` and
  :class:`~utils.NagWarning`) used throughout the `naginterfaces` package;

- a ``Handle`` data type used by some interfaces;

- a class called :class:`~utils.FileObjManager` (plus a module-level instance
  thereof) that is used to translate I/O between the NAG Engine and Python in
  certain cases;

- classes ``EngineIntNumPyType`` and ``EngineIntCType`` that can be used as
  integer types for compatibility with the NAG Engine integer on this platform;

- named constants that can be used with some functions, such as with
  ``blast.dgb_norm``.

Python interfaces are available for most algorithmic Chapters in the
NAG Library. However, we do not intend for these lower-level base
interfaces to be called directly from user code: please refer to the
:mod:`naginterfaces.library` subpackage instead.

Advanced Usage Notes
--------------------
For reference an extended description of the algorithmic interfaces in this
subpackage can be found in its accompanying ``README.rst`` file in the
`naginterfaces` source distribution.
"""

# NAG Copyright 2017-2018.
